
_Uart1_CRLn:

;ESP8266.mpas,29 :: 		begin
;ESP8266.mpas,30 :: 		Uart1_Write(#13);
	PUSH       R2
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
;ESP8266.mpas,31 :: 		Uart1_Write(#10);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ESP8266.mpas,32 :: 		end;
L_end_Uart1_CRLn:
	POP        R2
	RET
; end of _Uart1_CRLn

_Soft_UART_Text:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ESP8266.mpas,36 :: 		Begin
;ESP8266.mpas,38 :: 		For idx := 0 To Length(aText)-1 Do
; idx start address is: 20 (R20)
	LDI        R20, 0
; idx end address is: 20 (R20)
L__Soft_UART_Text2:
; idx start address is: 20 (R20)
	CALL       _Length+0
	SUBI       R16, 1
	SBCI       R17, 0
	STD        Y+0, R16
	STD        Y+1, R17
	CP         R16, R20
	LDI        R27, 0
	CPC        R17, R27
	BRSH       L__Soft_UART_Text96
	JMP        L__Soft_UART_Text6
L__Soft_UART_Text96:
;ESP8266.mpas,39 :: 		Soft_Uart_Write(aText[idx]);
	MOV        R30, R20
	LDI        R31, 0
	ADD        R30, R2
	ADC        R31, R3
	LD         R16, Z
	PUSH       R20
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _Soft_UART_Write+0
	POP        R2
	POP        R3
	POP        R4
	POP        R20
	MOV        R18, R20
	LDI        R19, 0
	LDD        R16, Y+0
	LDD        R17, Y+1
	CP         R18, R16
	CPC        R19, R17
	BRNE       L__Soft_UART_Text97
	JMP        L__Soft_UART_Text6
L__Soft_UART_Text97:
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
; idx end address is: 20 (R20)
	JMP        L__Soft_UART_Text2
L__Soft_UART_Text6:
;ESP8266.mpas,40 :: 		If CrLn Then Begin
	TST        R4
	BRNE       L__Soft_UART_Text98
	JMP        L__Soft_UART_Text8
L__Soft_UART_Text98:
;ESP8266.mpas,41 :: 		Soft_Uart_Write(#13);
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, 13
	MOV        R2, R27
	CALL       _Soft_UART_Write+0
;ESP8266.mpas,42 :: 		Soft_Uart_Write(#10);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _Soft_UART_Write+0
	POP        R2
	POP        R3
	POP        R4
;ESP8266.mpas,43 :: 		End;
L__Soft_UART_Text8:
;ESP8266.mpas,44 :: 		End;
L_end_Soft_UART_Text:
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Soft_UART_Text

_InitUart0:

;ESP8266.mpas,50 :: 		begin
;ESP8266.mpas,51 :: 		SREG_I_bit := 1;
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;ESP8266.mpas,52 :: 		RXCIE0_bit := 1;  // UCSR0B.7 := 1; -> enable USART receiver interrupt bit
	LDS        R27, RXCIE0_bit+0
	SBR        R27, BitMask(RXCIE0_bit+0)
	STS        RXCIE0_bit+0, R27
;ESP8266.mpas,53 :: 		RXEN0_bit  := 1;  // UCSR0B.4 := 1;
	LDS        R27, RXEN0_bit+0
	SBR        R27, BitMask(RXEN0_bit+0)
	STS        RXEN0_bit+0, R27
;ESP8266.mpas,54 :: 		end;
L_end_InitUart0:
	RET
; end of _InitUart0

_StopUart0:

;ESP8266.mpas,60 :: 		begin
;ESP8266.mpas,61 :: 		RXCIE0_bit := 0;  // UCSR0B.7 := 1; -> disable USART receiver interrupt bit
	LDS        R27, RXCIE0_bit+0
	CBR        R27, BitMask(RXCIE0_bit+0)
	STS        RXCIE0_bit+0, R27
;ESP8266.mpas,62 :: 		end;
L_end_StopUart0:
	RET
; end of _StopUart0

_StartUart0:

;ESP8266.mpas,69 :: 		begin
;ESP8266.mpas,70 :: 		RXCIE0_bit := 1;  // UCSR0B.7 := 1; -> enable USART receiver interrupt bit
	LDS        R27, RXCIE0_bit+0
	SBR        R27, BitMask(RXCIE0_bit+0)
	STS        RXCIE0_bit+0, R27
;ESP8266.mpas,71 :: 		end;
L_end_StartUart0:
	RET
; end of _StartUart0

_Uart1_Interrupt:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 6
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ESP8266.mpas,77 :: 		Begin
;ESP8266.mpas,78 :: 		c := UDR0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDS        R16, UDR0+0
	STS        _c+0, R16
;ESP8266.mpas,79 :: 		If sInputi < 78 Then Begin
	LDS        R16, _sInputi+0
	CPI        R16, 78
	BRLO       L__Uart1_Interrupt103
	JMP        L__Uart1_Interrupt15
L__Uart1_Interrupt103:
;ESP8266.mpas,80 :: 		sInputs := sInputs + c;
	LDI        R26, #lo_addr(_sInputs+0)
	LDI        R27, hi_addr(_sInputs+0)
	CALL       ___FZinS+0
	LDS        R16, _c+0
	ST         X+, R16
	LDI        R16, 0
	ST         X+, R16
;ESP8266.mpas,81 :: 		Inc(sInputi);
	LDS        R16, _sInputi+0
	MOV        R18, R16
	SUBI       R18, 255
	STS        _sInputi+0, R18
;ESP8266.mpas,82 :: 		sInputs[sInputi] := #0
	LDI        R16, #lo_addr(_sInputs+0)
	LDI        R17, hi_addr(_sInputs+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LDI        R27, 0
	ST         Z, R27
;ESP8266.mpas,83 :: 		End;
L__Uart1_Interrupt15:
;ESP8266.mpas,85 :: 		If sStart = 0 Then Begin                      // erstes Zeichen prfen
	LDS        R16, _sStart+0
	CPI        R16, 0
	BREQ       L__Uart1_Interrupt104
	JMP        L__Uart1_Interrupt18
L__Uart1_Interrupt104:
;ESP8266.mpas,86 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,87 :: 		sStatus := 0;
	LDI        R27, 0
	STS        _sStatus+0, R27
;ESP8266.mpas,88 :: 		if (c = 'R') OR (c='r') Then
	LDS        R16, _c+0
	CPI        R16, 82
	LDI        R17, 0
	BRNE       L__Uart1_Interrupt105
	LDI        R17, 255
L__Uart1_Interrupt105:
	CPI        R16, 114
	LDI        R27, 0
	BRNE       L__Uart1_Interrupt106
	LDI        R27, 255
L__Uart1_Interrupt106:
	MOV        R16, R27
	OR         R16, R17
	BRNE       L__Uart1_Interrupt107
	JMP        L__Uart1_Interrupt21
L__Uart1_Interrupt107:
;ESP8266.mpas,89 :: 		sStart := 1;
	LDI        R27, 1
	STS        _sStart+0, R27
L__Uart1_Interrupt21:
;ESP8266.mpas,90 :: 		If c = 'O' Then
	LDS        R16, _c+0
	CPI        R16, 79
	BREQ       L__Uart1_Interrupt108
	JMP        L__Uart1_Interrupt24
L__Uart1_Interrupt108:
;ESP8266.mpas,91 :: 		sStart := 2;
	LDI        R27, 2
	STS        _sStart+0, R27
L__Uart1_Interrupt24:
;ESP8266.mpas,92 :: 		If c = 'E' Then
	LDS        R16, _c+0
	CPI        R16, 69
	BREQ       L__Uart1_Interrupt109
	JMP        L__Uart1_Interrupt27
L__Uart1_Interrupt109:
;ESP8266.mpas,93 :: 		sStart := 2;
	LDI        R27, 2
	STS        _sStart+0, R27
L__Uart1_Interrupt27:
;ESP8266.mpas,94 :: 		End;
L__Uart1_Interrupt18:
;ESP8266.mpas,95 :: 		If sStart > 0 Then Begin
	LDS        R17, _sStart+0
	LDI        R16, 0
	CP         R16, R17
	BRLO       L__Uart1_Interrupt110
	JMP        L__Uart1_Interrupt30
L__Uart1_Interrupt110:
;ESP8266.mpas,96 :: 		sBuffer := sBuffer + c;
	LDI        R26, #lo_addr(_sBuffer+0)
	LDI        R27, hi_addr(_sBuffer+0)
	CALL       ___FZinS+0
	LDS        R16, _c+0
	ST         X+, R16
	LDI        R16, 0
	ST         X+, R16
;ESP8266.mpas,97 :: 		If sStart=1 Then Begin
	LDS        R16, _sStart+0
	CPI        R16, 1
	BREQ       L__Uart1_Interrupt111
	JMP        L__Uart1_Interrupt33
L__Uart1_Interrupt111:
;ESP8266.mpas,98 :: 		If (c='R') OR (c = 'r') OR (c = 'e') OR (c = 'a') OR (c = 'd') OR (c = 'y') Then Begin
	LDS        R18, _c+0
	CPI        R18, 82
	LDI        R17, 0
	BRNE       L__Uart1_Interrupt112
	LDI        R17, 255
L__Uart1_Interrupt112:
	CPI        R18, 114
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt113
	LDI        R16, 255
L__Uart1_Interrupt113:
	OR         R17, R16
	CPI        R18, 101
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt114
	LDI        R16, 255
L__Uart1_Interrupt114:
	OR         R17, R16
	CPI        R18, 97
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt115
	LDI        R16, 255
L__Uart1_Interrupt115:
	OR         R17, R16
	CPI        R18, 100
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt116
	LDI        R16, 255
L__Uart1_Interrupt116:
	OR         R17, R16
	CPI        R18, 121
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt117
	LDI        R16, 255
L__Uart1_Interrupt117:
	OR         R16, R17
	BRNE       L__Uart1_Interrupt118
	JMP        L__Uart1_Interrupt36
L__Uart1_Interrupt118:
;ESP8266.mpas,99 :: 		sPos := StrStr(sBuffer, 'Ready');
	MOVW       R30, R28
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 101
	ST         Z+, R27
	LDI        R27, 97
	ST         Z+, R27
	LDI        R27, 100
	ST         Z+, R27
	LDI        R27, 121
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, #lo_addr(_sBuffer+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_sBuffer+0)
	MOV        R3, R27
	CALL       _strstr+0
	STS        _sPos+0, R16
;ESP8266.mpas,100 :: 		If sPos <> 255 Then Begin
	CPI        R16, 255
	BRNE       L__Uart1_Interrupt119
	JMP        L__Uart1_Interrupt39
L__Uart1_Interrupt119:
;ESP8266.mpas,101 :: 		sStatus := 1;
	LDI        R27, 1
	STS        _sStatus+0, R27
;ESP8266.mpas,102 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,103 :: 		End;
L__Uart1_Interrupt39:
;ESP8266.mpas,104 :: 		End Else Begin
	JMP        L__Uart1_Interrupt37
L__Uart1_Interrupt36:
;ESP8266.mpas,105 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,106 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,107 :: 		End;
L__Uart1_Interrupt37:
;ESP8266.mpas,108 :: 		End;
L__Uart1_Interrupt33:
;ESP8266.mpas,109 :: 		If sStart=2 Then Begin
	LDS        R16, _sStart+0
	CPI        R16, 2
	BREQ       L__Uart1_Interrupt120
	JMP        L__Uart1_Interrupt42
L__Uart1_Interrupt120:
;ESP8266.mpas,110 :: 		If (c = 'O') OR (c = 'K') Then Begin
	LDS        R16, _c+0
	CPI        R16, 79
	LDI        R17, 0
	BRNE       L__Uart1_Interrupt121
	LDI        R17, 255
L__Uart1_Interrupt121:
	CPI        R16, 75
	LDI        R27, 0
	BRNE       L__Uart1_Interrupt122
	LDI        R27, 255
L__Uart1_Interrupt122:
	MOV        R16, R27
	OR         R16, R17
	BRNE       L__Uart1_Interrupt123
	JMP        L__Uart1_Interrupt45
L__Uart1_Interrupt123:
;ESP8266.mpas,111 :: 		sPos := StrStr(sBuffer, 'OK');
	LDI        R27, 79
	STD        Y+0, R27
	LDI        R27, 75
	STD        Y+1, R27
	LDI        R27, 0
	STD        Y+2, R27
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, #lo_addr(_sBuffer+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_sBuffer+0)
	MOV        R3, R27
	CALL       _strstr+0
	STS        _sPos+0, R16
;ESP8266.mpas,112 :: 		If sPos <> 255 Then Begin
	CPI        R16, 255
	BRNE       L__Uart1_Interrupt124
	JMP        L__Uart1_Interrupt48
L__Uart1_Interrupt124:
;ESP8266.mpas,113 :: 		sStatus := 2;
	LDI        R27, 2
	STS        _sStatus+0, R27
;ESP8266.mpas,114 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,115 :: 		End;
L__Uart1_Interrupt48:
;ESP8266.mpas,116 :: 		End Else Begin
	JMP        L__Uart1_Interrupt46
L__Uart1_Interrupt45:
;ESP8266.mpas,117 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,118 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,119 :: 		End;
L__Uart1_Interrupt46:
;ESP8266.mpas,120 :: 		End;
L__Uart1_Interrupt42:
;ESP8266.mpas,121 :: 		If sStart=1 Then Begin
	LDS        R16, _sStart+0
	CPI        R16, 1
	BREQ       L__Uart1_Interrupt125
	JMP        L__Uart1_Interrupt51
L__Uart1_Interrupt125:
;ESP8266.mpas,122 :: 		If (c='E') OR (c = 'R') OR (c = 'O') OR (c = 'R') Then Begin
	LDS        R18, _c+0
	CPI        R18, 69
	LDI        R17, 0
	BRNE       L__Uart1_Interrupt126
	LDI        R17, 255
L__Uart1_Interrupt126:
	CPI        R18, 82
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt127
	LDI        R16, 255
L__Uart1_Interrupt127:
	OR         R17, R16
	CPI        R18, 79
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt128
	LDI        R16, 255
L__Uart1_Interrupt128:
	OR         R17, R16
	CPI        R18, 82
	LDI        R16, 0
	BRNE       L__Uart1_Interrupt129
	LDI        R16, 255
L__Uart1_Interrupt129:
	OR         R16, R17
	BRNE       L__Uart1_Interrupt130
	JMP        L__Uart1_Interrupt54
L__Uart1_Interrupt130:
;ESP8266.mpas,123 :: 		sPos := StrStr(sBuffer, 'ERROR');
	MOVW       R30, R28
	LDI        R27, 69
	ST         Z+, R27
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 79
	ST         Z+, R27
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, #lo_addr(_sBuffer+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_sBuffer+0)
	MOV        R3, R27
	CALL       _strstr+0
	STS        _sPos+0, R16
;ESP8266.mpas,124 :: 		If sPos <> 255 Then Begin
	CPI        R16, 255
	BRNE       L__Uart1_Interrupt131
	JMP        L__Uart1_Interrupt57
L__Uart1_Interrupt131:
;ESP8266.mpas,125 :: 		sStatus := 1;
	LDI        R27, 1
	STS        _sStatus+0, R27
;ESP8266.mpas,126 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,127 :: 		End;
L__Uart1_Interrupt57:
;ESP8266.mpas,128 :: 		End Else Begin
	JMP        L__Uart1_Interrupt55
L__Uart1_Interrupt54:
;ESP8266.mpas,129 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,130 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,131 :: 		End;
L__Uart1_Interrupt55:
;ESP8266.mpas,132 :: 		End;
L__Uart1_Interrupt51:
;ESP8266.mpas,133 :: 		End;
L__Uart1_Interrupt30:
;ESP8266.mpas,134 :: 		End;
L_end_Uart1_Interrupt:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	ADIW       R28, 5
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _Uart1_Interrupt

_InitTimer0:

;ESP8266.mpas,140 :: 		begin
;ESP8266.mpas,141 :: 		SREG_I_bit := 1;
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;ESP8266.mpas,142 :: 		OCR0A    := 249;
	LDI        R27, 249
	OUT        OCR0A+0, R27
;ESP8266.mpas,143 :: 		CS00_Bit := 1;
	IN         R27, CS00_bit+0
	SBR        R27, BitMask(CS00_bit+0)
	OUT        CS00_bit+0, R27
;ESP8266.mpas,144 :: 		CS01_Bit := 1;
	IN         R27, CS01_bit+0
	SBR        R27, BitMask(CS01_bit+0)
	OUT        CS01_bit+0, R27
;ESP8266.mpas,145 :: 		CS02_Bit := 0;
	IN         R27, CS02_bit+0
	CBR        R27, BitMask(CS02_bit+0)
	OUT        CS02_bit+0, R27
;ESP8266.mpas,146 :: 		TCCR0A := 0x28;
	LDI        R27, 40
	OUT        TCCR0A+0, R27
;ESP8266.mpas,147 :: 		TCCR0A := TCCR0A or 0x03;
	LDI        R27, 43
	OUT        TCCR0A+0, R27
;ESP8266.mpas,148 :: 		OCIE0A_bit := 0;
	LDS        R27, OCIE0A_bit+0
	CBR        R27, BitMask(OCIE0A_bit+0)
	STS        OCIE0A_bit+0, R27
;ESP8266.mpas,149 :: 		end;
L_end_InitTimer0:
	RET
; end of _InitTimer0

_Timer0Overflow_ISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;ESP8266.mpas,155 :: 		begin
;ESP8266.mpas,156 :: 		Inc(Timer_Count);
	LDS        R16, _Timer_Count+0
	LDS        R17, _Timer_Count+1
	MOVW       R18, R16
	SUBI       R18, 255
	SBCI       R19, 255
	STS        _Timer_Count+0, R18
	STS        _Timer_Count+1, R19
;ESP8266.mpas,157 :: 		If Timer_Count >= Timer_Break Then Begin
	LDS        R16, _Timer_Break+0
	LDS        R17, _Timer_Break+1
	CP         R18, R16
	CPC        R19, R17
	BRGE       L__Timer0Overflow_ISR134
	JMP        L__Timer0Overflow_ISR62
L__Timer0Overflow_ISR134:
;ESP8266.mpas,158 :: 		TimeOut := True;
	LDI        R27, 255
	STS        _Timeout+0, R27
;ESP8266.mpas,159 :: 		OCIE0A_bit := 0;
	LDS        R27, OCIE0A_bit+0
	CBR        R27, BitMask(OCIE0A_bit+0)
	STS        OCIE0A_bit+0, R27
;ESP8266.mpas,160 :: 		End;
L__Timer0Overflow_ISR62:
;ESP8266.mpas,161 :: 		end;
L_end_Timer0Overflow_ISR:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _Timer0Overflow_ISR

_Timer_Start:

;ESP8266.mpas,167 :: 		begin
;ESP8266.mpas,168 :: 		OCIE0A_bit  := 0;
	LDS        R27, OCIE0A_bit+0
	CBR        R27, BitMask(OCIE0A_bit+0)
	STS        OCIE0A_bit+0, R27
;ESP8266.mpas,169 :: 		Timer_Count := 0;
	LDI        R27, 0
	STS        _Timer_Count+0, R27
	STS        _Timer_Count+1, R27
;ESP8266.mpas,170 :: 		Timer_Break := aValue;
	STS        _Timer_Break+0, R2
	STS        _Timer_Break+1, R3
;ESP8266.mpas,171 :: 		TimeOut := False;
	LDI        R27, 0
	STS        _Timeout+0, R27
;ESP8266.mpas,172 :: 		OCIE0A_bit  := 1;
	LDS        R27, OCIE0A_bit+0
	SBR        R27, BitMask(OCIE0A_bit+0)
	STS        OCIE0A_bit+0, R27
;ESP8266.mpas,173 :: 		end;
L_end_Timer_Start:
	RET
; end of _Timer_Start

_Timer_Stop:

;ESP8266.mpas,179 :: 		begin
;ESP8266.mpas,180 :: 		OCIE0A_bit  := 0;
	LDS        R27, OCIE0A_bit+0
	CBR        R27, BitMask(OCIE0A_bit+0)
	STS        OCIE0A_bit+0, R27
;ESP8266.mpas,181 :: 		end;
L_end_Timer_Stop:
	RET
; end of _Timer_Stop

_ReceiveStatus:

;ESP8266.mpas,184 :: 		Begin
;ESP8266.mpas,185 :: 		Timer_Start(aValue);
	CALL       _Timer_Start+0
;ESP8266.mpas,186 :: 		Repeat
L__ReceiveStatus67:
;ESP8266.mpas,187 :: 		Until (sStatus > 0) OR TimeOut;
	LDS        R17, _sStatus+0
	LDI        R16, 0
	CP         R16, R17
	LDI        R17, 0
	BRSH       L__ReceiveStatus138
	LDI        R17, 255
L__ReceiveStatus138:
	LDS        R16, _Timeout+0
	OR         R16, R17
	BRNE       L__ReceiveStatus139
	JMP        L__ReceiveStatus67
L__ReceiveStatus139:
;ESP8266.mpas,188 :: 		Result := sStatus;
; Result start address is: 18 (R18)
	LDS        R18, _sStatus+0
	LDI        R19, 0
;ESP8266.mpas,189 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,190 :: 		End;
	MOVW       R16, R18
; Result end address is: 18 (R18)
L_end_ReceiveStatus:
	RET
; end of _ReceiveStatus

_EPS8266_Cmd:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SUBI       R28, 101
	SBCI       R29, 0
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ESP8266.mpas,193 :: 		Begin
;ESP8266.mpas,194 :: 		sInputi := 0;
	PUSH       R4
	LDI        R27, 0
	STS        _sInputi+0, R27
;ESP8266.mpas,195 :: 		sInputs := '';
	LDI        R27, 0
	STS        _sInputs+0, R27
;ESP8266.mpas,197 :: 		Soft_Uart_Text('Command: ', True);
	MOVW       R30, R28
	ADIW       R30, 2
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 111
	ST         Z+, R27
	LDI        R27, 109
	ST         Z+, R27
	LDI        R27, 109
	ST         Z+, R27
	LDI        R27, 97
	ST         Z+, R27
	LDI        R27, 110
	ST         Z+, R27
	LDI        R27, 100
	ST         Z+, R27
	LDI        R27, 58
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	SUBI       R16, 254
	SBCI       R17, 255
	PUSH       R3
	PUSH       R2
	LDI        R27, 255
	MOV        R4, R27
	MOVW       R2, R16
	CALL       _Soft_UART_Text+0
	POP        R2
	POP        R3
;ESP8266.mpas,198 :: 		Soft_Uart_Text(aStr, True);
	PUSH       R3
	PUSH       R2
	LDI        R27, 255
	MOV        R4, R27
	CALL       _Soft_UART_Text+0
	POP        R2
	POP        R3
;ESP8266.mpas,200 :: 		StartUart0();
	CALL       _StartUart0+0
;ESP8266.mpas,201 :: 		j := 0;
	LDI        R27, 0
	STS        _j+0, R27
;ESP8266.mpas,202 :: 		Repeat
L__EPS8266_Cmd73:
;ESP8266.mpas,203 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,204 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,205 :: 		sStatus := 0;
	LDI        R27, 0
	STS        _sStatus+0, R27
;ESP8266.mpas,206 :: 		Uart1_Write_Text(aStr);
	CALL       _UART1_Write_Text+0
;ESP8266.mpas,207 :: 		Uart1_Write(#13);
	PUSH       R3
	PUSH       R2
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
;ESP8266.mpas,208 :: 		Uart1_Write(#10);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ESP8266.mpas,209 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L__EPS8266_Cmd78:
	DEC        R16
	BRNE       L__EPS8266_Cmd78
	DEC        R17
	BRNE       L__EPS8266_Cmd78
	DEC        R18
	BRNE       L__EPS8266_Cmd78
	NOP
;ESP8266.mpas,210 :: 		i := ReceiveStatus(5000);
	LDI        R27, 136
	MOV        R2, R27
	LDI        R27, 19
	MOV        R3, R27
	CALL       _ReceiveStatus+0
	POP        R2
	POP        R3
	STS        _i+0, R16
;ESP8266.mpas,211 :: 		Inc(j);
	LDS        R18, _j+0
	MOV        R19, R18
	SUBI       R19, 255
	STS        _j+0, R19
;ESP8266.mpas,212 :: 		Until (i > 0) OR (j = 2);
	LDI        R18, 0
	CP         R18, R16
	LDI        R17, 0
	BRSH       L__EPS8266_Cmd141
	LDI        R17, 255
L__EPS8266_Cmd141:
	CPI        R19, 2
	LDI        R16, 0
	BRNE       L__EPS8266_Cmd142
	LDI        R16, 255
L__EPS8266_Cmd142:
	OR         R16, R17
	BREQ       L__EPS8266_Cmd143
	JMP        L__EPS8266_Cmd76
L__EPS8266_Cmd143:
	JMP        L__EPS8266_Cmd73
L__EPS8266_Cmd76:
;ESP8266.mpas,213 :: 		Result := i;
	LDS        R16, _i+0
	STD        Y+0, R16
	LDI        R27, 0
	STD        Y+1, R27
;ESP8266.mpas,215 :: 		Soft_Uart_Text('Status: '+sBuffer, False);
	MOV        R26, R28
	MOV        R27, R29
	SUBI       R26, 244
	SBCI       R27, 255
	LDI        R16, 83
	ST         X+, R16
	LDI        R16, 116
	ST         X+, R16
	LDI        R16, 97
	ST         X+, R16
	LDI        R16, 116
	ST         X+, R16
	LDI        R16, 117
	ST         X+, R16
	LDI        R16, 115
	ST         X+, R16
	LDI        R16, 58
	ST         X+, R16
	LDI        R16, 32
	ST         X+, R16
	LDI        R30, #lo_addr(_sBuffer+0)
	LDI        R31, hi_addr(_sBuffer+0)
	CALL       ___CS2S+0
	LDI        R16, 0
	ST         X+, R16
	MOVW       R16, R28
	SUBI       R16, 244
	SBCI       R17, 255
	PUSH       R3
	PUSH       R2
	CLR        R4
	MOVW       R2, R16
	CALL       _Soft_UART_Text+0
;ESP8266.mpas,216 :: 		ByteToStr(j, s);
	LDI        R27, #lo_addr(_s+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_s+0)
	MOV        R4, R27
	LDS        R2, _j+0
	CALL       _ByteToStr+0
	POP        R2
	POP        R3
;ESP8266.mpas,217 :: 		Soft_Uart_Text(' Versuche: '+s, True);
	MOV        R26, R28
	MOV        R27, R29
	SUBI       R26, 244
	SBCI       R27, 255
	LDI        R16, 32
	ST         X+, R16
	LDI        R16, 86
	ST         X+, R16
	LDI        R16, 101
	ST         X+, R16
	LDI        R16, 114
	ST         X+, R16
	LDI        R16, 115
	ST         X+, R16
	LDI        R16, 117
	ST         X+, R16
	LDI        R16, 99
	ST         X+, R16
	LDI        R16, 104
	ST         X+, R16
	LDI        R16, 101
	ST         X+, R16
	LDI        R16, 58
	ST         X+, R16
	LDI        R16, 32
	ST         X+, R16
	LDI        R30, #lo_addr(_s+0)
	LDI        R31, hi_addr(_s+0)
	CALL       ___CS2S+0
	LDI        R16, 0
	ST         X+, R16
	MOVW       R16, R28
	SUBI       R16, 244
	SBCI       R17, 255
	PUSH       R3
	PUSH       R2
	LDI        R27, 255
	MOV        R4, R27
	MOVW       R2, R16
	CALL       _Soft_UART_Text+0
	POP        R2
	POP        R3
;ESP8266.mpas,218 :: 		Soft_Uart_Text('Result: '+sInputs, True);
	MOV        R26, R28
	MOV        R27, R29
	SUBI       R26, 244
	SBCI       R27, 255
	LDI        R16, 82
	ST         X+, R16
	LDI        R16, 101
	ST         X+, R16
	LDI        R16, 115
	ST         X+, R16
	LDI        R16, 117
	ST         X+, R16
	LDI        R16, 108
	ST         X+, R16
	LDI        R16, 116
	ST         X+, R16
	LDI        R16, 58
	ST         X+, R16
	LDI        R16, 32
	ST         X+, R16
	LDI        R30, #lo_addr(_sInputs+0)
	LDI        R31, hi_addr(_sInputs+0)
	CALL       ___CS2S+0
	LDI        R16, 0
	ST         X+, R16
	MOVW       R16, R28
	SUBI       R16, 244
	SBCI       R17, 255
	PUSH       R3
	PUSH       R2
	LDI        R27, 255
	MOV        R4, R27
	MOVW       R2, R16
	CALL       _Soft_UART_Text+0
	POP        R2
	POP        R3
;ESP8266.mpas,219 :: 		Delay_ms(500); // Restliche Zeichen einlesen lassen
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L__EPS8266_Cmd80:
	DEC        R16
	BRNE       L__EPS8266_Cmd80
	DEC        R17
	BRNE       L__EPS8266_Cmd80
	DEC        R18
	BRNE       L__EPS8266_Cmd80
;ESP8266.mpas,220 :: 		StopUart0();
	CALL       _StopUart0+0
;ESP8266.mpas,221 :: 		End;
	LDD        R16, Y+0
	LDD        R17, Y+1
L_end_EPS8266_Cmd:
	POP        R4
	SUBI       R28, 156
	SBCI       R29, 255
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _EPS8266_Cmd

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 43
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ESP8266.mpas,223 :: 		begin
;ESP8266.mpas,226 :: 		sBuffer := '';
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	PUSH       R9
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,227 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,228 :: 		sStatus := 0;
	LDI        R27, 0
	STS        _sStatus+0, R27
;ESP8266.mpas,230 :: 		Soft_UART_Init(PORTB, 2, 3, 9600, 0);
	LDI        R27, 128
	MOV        R6, R27
	LDI        R27, 37
	MOV        R7, R27
	LDI        R27, 0
	MOV        R8, R27
	MOV        R9, R27
	LDI        R27, 3
	MOV        R5, R27
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	LDI        R27, 0
	PUSH       R27
	CALL       _Soft_UART_Init+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 1
	OUT        SPL+0, R26
	OUT        SPL+1, R27
;ESP8266.mpas,231 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L__main83:
	DEC        R16
	BRNE       L__main83
	DEC        R17
	BRNE       L__main83
	DEC        R18
	BRNE       L__main83
	NOP
;ESP8266.mpas,232 :: 		UART1_init(9600);
	LDI        R27, 103
	STS        UBRR0L+0, R27
	LDI        R27, 0
	STS        UBRR0H+0, R27
	CALL       _UART1_Init+0
;ESP8266.mpas,233 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L__main85:
	DEC        R16
	BRNE       L__main85
	DEC        R17
	BRNE       L__main85
	DEC        R18
	BRNE       L__main85
	NOP
;ESP8266.mpas,235 :: 		s := DoGetDateTime();
	LDI        R30, #lo_addr(_s+0)
	LDI        R31, hi_addr(_s+0)
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 46
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 51
	ST         Z+, R27
	LDI        R27, 46
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 58
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 58
	ST         Z+, R27
	LDI        R27, 50
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
;ESP8266.mpas,236 :: 		Soft_UART_Text(s, True);
	LDI        R27, 255
	MOV        R4, R27
	LDI        R27, #lo_addr(_s+0)
	MOV        R2, R27
	LDI        R27, hi_addr(_s+0)
	MOV        R3, R27
	CALL       _Soft_UART_Text+0
;ESP8266.mpas,238 :: 		InitUart0();
	CALL       _InitUart0+0
;ESP8266.mpas,239 :: 		InitTimer0();
	CALL       _InitTimer0+0
;ESP8266.mpas,240 :: 		Delay_ms(500);
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L__main87:
	DEC        R16
	BRNE       L__main87
	DEC        R17
	BRNE       L__main87
	DEC        R18
	BRNE       L__main87
;ESP8266.mpas,242 :: 		sBuffer := '';
	LDI        R27, 0
	STS        _sBuffer+0, R27
;ESP8266.mpas,243 :: 		sStart  := 0;
	LDI        R27, 0
	STS        _sStart+0, R27
;ESP8266.mpas,244 :: 		sStatus := 0;
	LDI        R27, 0
	STS        _sStatus+0, R27
;ESP8266.mpas,246 :: 		EPS8266_Cmd('AT+RST');
	MOVW       R30, R28
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 43
	ST         Z+, R27
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 83
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _EPS8266_Cmd+0
;ESP8266.mpas,248 :: 		EPS8266_Cmd('AT+CWMODE=1');
	MOVW       R30, R28
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 43
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 87
	ST         Z+, R27
	LDI        R27, 77
	ST         Z+, R27
	LDI        R27, 79
	ST         Z+, R27
	LDI        R27, 68
	ST         Z+, R27
	LDI        R27, 69
	ST         Z+, R27
	LDI        R27, 61
	ST         Z+, R27
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _EPS8266_Cmd+0
;ESP8266.mpas,251 :: 		EPS8266_Cmd('AT+CWJAP="ClasaniFaber","0581579335765689"');
	MOVW       R30, R28
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 43
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 87
	ST         Z+, R27
	LDI        R27, 74
	ST         Z+, R27
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 80
	ST         Z+, R27
	LDI        R27, 61
	ST         Z+, R27
	LDI        R27, 34
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 108
	ST         Z+, R27
	LDI        R27, 97
	ST         Z+, R27
	LDI        R27, 115
	ST         Z+, R27
	LDI        R27, 97
	ST         Z+, R27
	LDI        R27, 110
	ST         Z+, R27
	LDI        R27, 105
	ST         Z+, R27
	LDI        R27, 70
	ST         Z+, R27
	LDI        R27, 97
	ST         Z+, R27
	LDI        R27, 98
	ST         Z+, R27
	LDI        R27, 101
	ST         Z+, R27
	LDI        R27, 114
	ST         Z+, R27
	LDI        R27, 34
	ST         Z+, R27
	LDI        R27, 44
	ST         Z+, R27
	LDI        R27, 34
	ST         Z+, R27
	LDI        R27, 48
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 56
	ST         Z+, R27
	LDI        R27, 49
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 55
	ST         Z+, R27
	LDI        R27, 57
	ST         Z+, R27
	LDI        R27, 51
	ST         Z+, R27
	LDI        R27, 51
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 55
	ST         Z+, R27
	LDI        R27, 54
	ST         Z+, R27
	LDI        R27, 53
	ST         Z+, R27
	LDI        R27, 54
	ST         Z+, R27
	LDI        R27, 56
	ST         Z+, R27
	LDI        R27, 57
	ST         Z+, R27
	LDI        R27, 34
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _EPS8266_Cmd+0
;ESP8266.mpas,253 :: 		EPS8266_Cmd('AT+CIFSR');
	MOVW       R30, R28
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 43
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 73
	ST         Z+, R27
	LDI        R27, 70
	ST         Z+, R27
	LDI        R27, 83
	ST         Z+, R27
	LDI        R27, 82
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _EPS8266_Cmd+0
;ESP8266.mpas,255 :: 		EPS8266_Cmd('AT+CIPSTAMAC?');
	MOVW       R30, R28
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 43
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 73
	ST         Z+, R27
	LDI        R27, 80
	ST         Z+, R27
	LDI        R27, 83
	ST         Z+, R27
	LDI        R27, 84
	ST         Z+, R27
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 77
	ST         Z+, R27
	LDI        R27, 65
	ST         Z+, R27
	LDI        R27, 67
	ST         Z+, R27
	LDI        R27, 63
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _EPS8266_Cmd+0
;ESP8266.mpas,258 :: 		While TRUE do begin
L__main90:
	JMP        L__main90
;ESP8266.mpas,261 :: 		end.
L_end_main:
	POP        R9
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
